<script setup>
import { ref, computed, watch, onMounted } from 'vue'
import Navigation from "@/components/Navigation.vue";
import axios from "axios";
import { Modal } from "bootstrap";
import TuiCalendar from "toast-ui-calendar-vue3";
import "toast-ui-calendar-vue3/dist/style.css";
import CreateTimeslot from './CreateTimeslot.vue';
import UpdateTimeslot from './UpdateTimeslot.vue';
import DeleteTimeslot from './DeleteTimeslot.vue';

const props = defineProps({
  places: Array,
  employees: Array,
  subjects: Array,
  promotions: Array,
  manage: Boolean
})

const places = computed(() => props.places)
const employees = computed(() => props.employees)
const subjects = computed(() => props.subjects)
const promotions = computed(() => props.promotions)

const timeslots = ref([])
const emit = defineEmits(['update-timeslots'])


const currentPromotion = ref()

watch(currentPromotion, (newValue) => {
  updateTimeslots(newValue)
})

function updateTimeslots(promotion) {
  axios.get(`${import.meta.env.VITE_GESTION_EDT_API_URL}/creneaux/promotion/${promotion}`, {
    headers : {
      'Content-Type': 'application/json',
      'Accept': 'application/json'
    },
  })
    .then(response => {
      timeslots.value = response.data
      emit('update-timeslots', timeslots.value)
    })
    .catch(e => {
      console.log(e)
  })
}

const currentDate = ref(new Date())

const options = computed(() => ({
  week: {
    dayNames: ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'],
    startDayOfWeek: 1,
    narrowWeekend: false,
    workweek: false,
    showNowIndicator: true,
    showTimezoneCollapseButton: false,
    timezonesCollapsed: false,
    hourStart: 6,
    hourEnd: 21,
    eventView: ['time'],
    taskView: false,
    collapseDuplicateEvents: true,
  },
}))

const views = computed(() => (
  promotions.value.map((promotion, index) => ({
    id: `promotion-${index}`,
    name: promotion.intitule
  }))
))

let modal_create = ref(null)
let modalCreate = ref(null)
let modal_update = ref(null)
let modalUpdate = ref(null)
let modal_delete = ref(null)
let modalDelete = ref(null)

const startDate = ref(currentDate.value)
const endDate = ref(currentDate.value)

const eventToUpdate = ref(null)
const eventChanges = ref(null)
const eventToDelete = ref(null)

const calendarRef = ref(null)
const calendar = ref(null)
onMounted(() => {
  modalCreate = new Modal(modal_create.value)
  modalUpdate = new Modal(modal_update.value)
  modalDelete = new Modal(modal_delete.value)

  calendar.value = calendarRef.value.getInstance()

  calendar.value.on('beforeDeleteEvent', (e) => {
    eventToDelete.value = e
    modalDelete.show()
  })

  calendar.value.on('beforeUpdateEvent', (e) => {
    eventToUpdate.value = e.event
    eventChanges.value = e.changes
    modalUpdate.show()
  })

  calendar.value.on('selectDateTime', (e) => {
    if (!props.manage) {
      return
    }

    startDate.value = e.start
    endDate.value = e.end

    modalCreate.show()
  })
})

const events = computed(() => (
  timeslots.value.map((timeslot) => ({
    id: `${timeslot.timeslotIdDTO}`,
    title: subjects.value.find(subject => subject.id === timeslot.materialIdDTO)?.intitule || 'Inconnu',
    category: 'time',
    start: timeslot.startDateDTO,
    end: timeslot.endDateDTO,
    state: '',
    isReadOnly: !props.manage,
    location: places.value.find(place => place.placeIdDTO === timeslot.placeIdDTO)?.roomDTO || 'Inconnu',
    attendees: Array(timeslot.employeeIdsDTO.map(id => employees.value.find(employee => employee.id === id)?.nom + ' ' + employees.value.find(employee => employee.id === id)?.prenom).join(', ') || 'Inconnu'),
    body: String(timeslot.promotionIdsDTO.map(id => promotions.value.find(promotion => promotion.id === id)?.intitule).join(', ') || 'Inconnu'),
  }))
))

watch(currentDate, (newValue) => {
  calendar.value.setDate(newValue)
})

const template = {
  // display in 24h format
  timegridDisplayPrimaryTime({ time }) {
      return `${time.getHours()} h`;
  },
  popupDetailDate({ start, end }) {
    return `${start.getFullYear()}/${(start.getMonth() + 1).toString().padStart(2, '0')}/${start.getDate().toString().padStart(2, '0')} : ${start.getHours().toString().padStart(2, '0')}h${start.getMinutes().toString().padStart(2, '0')} - ${end.getHours().toString().padStart(2, '0')}h${end.getMinutes().toString().padStart(2, '0')}`;
  },
  popupEdit() {
    return '';
  },
  popupDelete() {
    return '';
  },
  time(event) {
    return `
      <span style="font-weight: bold;">
        ${event.start.getHours().toString().padStart(2, '0')}:${event.start.getMinutes().toString().padStart(2, '0')}
      </span> - <span style="font-weight: bold;">
        ${event.end.getHours().toString().padStart(2, '0')}:${event.end.getMinutes().toString().padStart(2, '0')}
      </span>
      <br>${event.title}<br>${event.location}<br>${event.attendees}`;
  },
}
</script>

<template>
    <div class="timetable">
      <Navigation :currentDate="currentDate" :promotions="promotions" @update-date="currentDate = $event" @update-promotion="currentPromotion = $event" />
      <tui-calendar
        class="my-calendar"
        ref="calendarRef"
        view="week"
        timezone="Europe/Paris"
        :value="currentDate"
        :use-form-popup=false
        :use-detail-popup=true
        :usage-statistics=false
        :week="options.week"
        :calendars="views"
        :events="events"
        :template="template"
      />

      <div class="modal fade" ref="modal_create" tabindex="-1">
        <div class="modal-dialog" >
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title">Create a timeslot</h5>
              <button class="btn-close close" @click="modalCreate.hide()" aria-label="Close"></button>
            </div>
            <div class="modal-body" >
              <CreateTimeslot 
                :startDate="startDate" 
                :endDate="endDate" 
                :promotions="promotions" 
                :currentPromotion="currentPromotion" 
                :places="places" 
                :employees="employees" 
                :subjects="subjects" 
                @exit="modalCreate.hide(); updateTimeslots(currentPromotion)"
              />
            </div>
          </div>
        </div>
      </div>

      <div class="modal fade" ref="modal_update" tabindex="-1">
        <div class="modal-dialog" >
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title">Update a timeslot</h5>
              <button class="btn-close close" @click="modalUpdate.hide()" aria-label="Close"></button>
            </div>
            <div class="modal-body" >
              <UpdateTimeslot 
                :event="eventToUpdate"
                :changes="eventChanges" 
                :promotions="promotions" 
                :places="places" 
                :employees="employees" 
                :subjects="subjects" 
                @exit="modalUpdate.hide(); updateTimeslots(currentPromotion)"
              />
            </div>
          </div>
        </div>
      </div>

      <div class="modal fade" ref="modal_delete" tabindex="-1">
        <div class="modal-dialog" >
          <div class="modal-content">
            <div class="modal-header">
              <h5 class="modal-title">Delete a timeslot</h5>
              <button class="btn-close close" @click="modalDelete.hide()" aria-label="Close"></button>
            </div>
            <div class="modal-body" >
              <DeleteTimeslot 
                :event="eventToDelete"
                @exit="modalDelete.hide(); updateTimeslots(currentPromotion)"
              />
            </div>
          </div>
        </div>
      </div>

    </div>
</template>

<style scoped>
.timetable {
  display: flex;
  flex-direction: column;
  padding: 8px;
  width: 100%;
  color: #000;
}

</style>

<style>

.toastui-calendar-day-names, .toastui-calendar-week {
  overflow: hidden !important;
}
</style>